ompi/mca/coll/sm/coll_sm_bcast.c File Reference.TH "ompi/mca/coll/sm/coll_sm_bcast.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/coll/sm/coll_sm_bcast.c \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'ompi/include/constants.h'\fP
.br
\fC#include 'ompi/communicator/communicator.h'\fP
.br
\fC#include 'ompi/datatype/convertor.h'\fP
.br
\fC#include 'ompi/mca/coll/coll.h'\fP
.br
\fC#include 'opal/include/sys/atomic.h'\fP
.br
\fC#include 'coll_sm.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_coll_sm_bcast_intra\fP (void *buff, int count, struct ompi_datatype_t *datatype, int root, struct ompi_communicator_t *comm)"
.br
.RI "\fIShared memory broadcast. \fP"
.in -1c
.SH "Detailed Description"
.PP 

.SH "Function Documentation"
.PP 
.SS "int mca_coll_sm_bcast_intra (void * buff, int count, struct ompi_datatype_t * datatype, int root, struct ompi_communicator_t * comm)"
.PP
Shared memory broadcast. 
.PP
For the root, the general algorithm is to wait for a set of segments to become available. Once it is, the root claims the set by writing the current operation number and the number of processes using the set to the flag. The root then loops over the set of segments; for each segment, it copies a fragment of the user's buffer into the shared data segment and then writes the data size into its childrens' control buffers. The process is repeated until all fragments have been written.
.PP
For non-roots, for each set of buffers, they wait until the current operation number appears in the in-use flag (i.e., written by the root). Then for each segment, they wait for a nonzero to appear into their control buffers. If they have children, they copy the data from their parent's shared data segment into their shared data segment, and write the data size into each of their childrens' control buffers. They then copy the data from their shared [local] data segment into the user's output buffer. The process is repeated until all fragments have been received. If they do not have children, they copy the data directly from the parent's shared data segment into the user's output buffer. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
